QGIS Application - Bug report #18254
Topology checker thinks everything is a multipart polygon
2018-02-27 07:02 PM - Bartosz Mazurkiewicz

Status: Closed

Priority: Normal

Assignee:

Category: C++ plugins/Topology checker

Affected QGIS version:3.0.0 Regression?: No

Operating System: Windows 7, 64 bit Easy fix?: No

Pull Request or Patch supplied: Resolution: no timely feedback
Crashes QGIS or corrupls data: Copied to github as #: 26145
Description

The topology checker does not work well in qgis3.

Even with a just by hand created polygon layer it shows that every polygon is a multipart one.

History

#1 - 2018-02-27 07:07 PM - Giovanni Manghi
- Status changed from Open to Feedback

Does it works differently in 2.18?

Please add detailed steps to allow others easily replicate the issue.

#2 - 2018-02-27 10:06 PM - Bartosz Mazurkiewicz

Giovanni Manghi wrote:

Does it works differently in 2.187?

Please add detailed steps to allow others easily replicate the issue.

Yes in 2.18 the same shapefile does not show "is multipart" error.

| tried it with various shapefiles. Even one manually created and certainly not multipart.

#3 - 2018-02-27 11:21 PM - Nyall Dawson

Actually this was an intentional change in 3.0. Because shapefile don't have strict single/multi types for line/polygon layers (they only do for
point/multipoint) there was some heuristics in QGIS to detect whether a layer contained single or multi part geometries. But it was fragile and broke in many
cases, causing layers which were reported as single part types to sometimes still return multi part features.

To solve this qgis now treats all shapefile line/polygon layers as multipart and returns multipart features from these layers.

In other words - it's another shapefile limitation.

#4 - 2018-02-27 11:23 PM - Giovanni Manghi
Nyall Dawson wrote:
Actually this was an intentional change in 3.0. Because shapefile don't have strict single/multi types for line/polygon layers (they only do for
point/multipoint) there was some heuristics in QGIS to detect whether a layer contained single or multi part geometries. But it was fragile and broke

in many cases, causing layers which were reported as single part types to sometimes still return multi part features.

To solve this qgis now treats all shapefile line/polygon layers as multipart and returns multipart features from these layers.

In other words - it's another shapefile limitation.

closing?

#5 - 2018-02-28 08:26 AM - Bartosz Mazurkiewicz

Giovanni Manghi wrote:

Nyall Dawson wrote:
Actually this was an intentional change in 3.0. Because shapefile don't have strict single/multi types for line/polygon layers (they only do for
point/multipoint) there was some heuristics in QGIS to detect whether a layer contained single or multi part geometries. But it was fragile and broke

in many cases, causing layers which were reported as single part types to sometimes still return multi part features.

To solve this qgis now treats all shapefile line/polygon layers as multipart and returns multipart features from these layers.

In other words - it's another shapefile limitation.

closing?

Thank you for the explanation.

So wouldn't be better to eliminate this topology test for line/polygon shapefiles if it always fails for them? Maybe adding something in the help section of the

tool?

#6 - 2018-02-28 10:32 AM - Giovanni Manghi

So wouldn't be better to eliminate this topology test for line/polygon shapefiles if it always fails for them? Maybe adding something in the help section
of the tool?

give a try to the "geometry checker" core tool. The "topology checker" is (as far as | know) unmaintained.

#7 - 2018-08-22 10:50 AM - Giovanni Manghi
Nyall Dawson wrote:
Actually this was an intentional change in 3.0. Because shapefile don't have strict single/multi types for line/polygon layers (they only do for

point/multipoint) there was some heuristics in QGIS to detect whether a layer contained single or multi part geometries. But it was fragile and broke

in many cases, causing layers which were reported as single part types to sometimes still return multi part features.
To solve this qgis now treats all shapefile line/polygon layers as multipart and returns multipart features from these layers.

In other words - it's another shapefile limitation.

considered also this

https://github.com/qgis/QGIS-Enhancement-Proposals/issues/131#issuecomment-414785213

should we close this?

#8 - 2019-02-23 08:36 PM - Juirgen Fischer
- Resolution set to no timely feedback
- Status changed from Feedback to Closed

Bulk closing 82 tickets in feedback state for more than 90 days affecting an old version. Feel free to reopen if it still applies to a current version and you

have more information that clarify the issue.
